;
; This is public domain
;

bits 32

%define N	65536	;N must be 65536 - the code rely on it !!!

;some globals I must define at beginning of code
;should not be here, but it's nasm, yah know... (well, it's more _my_ use of nasm)
;it's all inited at 0 by linux, cool, nope ?
%define ifft_W		(0x18004000)		;complex ifft_W[N];
%define fft_data	(ifft_W+N*8)		;complex fft_data[N];
%define ifft_data	(fft_data+N*8)		;complex ifft_data[N];
%define ifft_out	(ifft_data+N*8)		;short ifft_out[N];
%define unpacked_voice	(ifft_out+N*2)		;char buf[N];
%define sound_buf	(unpacked_voice+N)	;char sound_buf[4096]
%define voice_pointer	(sound_buf+4096)	;int voice_pointer
%define m1		(voice_pointer+4)
%define m1_length	m1			;int
%define m1_cur		(m1_length+4)		;int
%define m1_high		(m1_cur+4)		;int
%define m1_pos		(m1_high+4)		;int
%define m2		(m1_pos+4)
%define m2_length	m2			;int
%define m2_cur		(m2_length+4)		;int
%define m2_high		(m2_cur+4)		;int
%define m2_pos		(m2_high+4)		;int

%define mandel_data	(ifft_W)			;320*240 ;m2_pos+4
%define screen		(mandel_data+65536*2)	;320*240
%define init_time	(screen+65536*2)	;int
%define sinus_tab3	(init_time+512)		;char sinus_tab3[512]
%define unpack_sed	(sinus_tab3+512)	;char sed[60*32]
%define unpack_present	(unpack_sed+2048)	;char present[80*27]
%define unpack_fourvoyement (unpack_present+4096) ;char fourvoyement[103*16]
%define sinus_tab4	(unpack_fourvoyement+4096) ;int sinus_tab4[512]   : in 1/1024
%define cosinus_tab4	(sinus_tab4+512*4)	;int cosinus_tab4[512]    : in 1/1024

%define plasma_old	(m2_pos+4)		;int
%define angle1		(plasma_old+4)		;int
%define angle2		(angle1+4)		;int
%define angle3		(angle2+4)		;int
%define angle4		(angle3+4)		;int
%define x		(angle4+4)		;int
%define y		(x+4)			;int
%define screen_mode	(y+4)
%define __screen_pointer (screen_mode+16)
%define __put_screen	(__screen_pointer+16)
;char screen_mode[160]

org 0x1800004a
push ebp
mov ebp, esp
mov eax, [ebp+8]
mov [__screen_pointer], eax
mov eax, [ebp+12]
mov [__put_screen], eax
	;first of all, unpack voice
	call	init_fft

	xor	eax, eax
	xor	edx, edx
	xor	ecx, ecx
	mov	edi, fft_data
	mov	esi, voice_data
	cld
ma:	mov	[edi+4], ecx
	cmp	dx, 1600
	jb	mn1
	cmp	dx, 1600+400
	jb	mok
	cmp	dx, 3600
	jb	mn1
	cmp	dx, 3600+300
	jb	mok
	cmp	dx, 5400
	jb	mn1
	cmp	dx, 5400+300
	jb	mok
mn1:	mov	[edi], ecx
	clc
	jnc	maf
mok:	lodsb
	shl	eax, 18+6
	sar	eax, 6
	mov	[edi], eax
	fild	dword [edi]
	fstp	dword [edi]
maf:	add	edi, 8
	inc	dx
	jnz	ma

	call	ifft

	xor	ebx, ebx
	xor	eax, eax
	mov	al, 128
	push	eax
	fild	dword [esp]
	mov	al, 255
	push	eax
	fild	dword [esp]
	push	dword 65535
	fidiv	dword [esp]
	pop	eax
	pop	eax
	mov	esi, ifft_out
	mov	edi, unpacked_voice
mb:	fld	st0
	fimul	word [esi]
	fadd	st2
	fistp	dword [esp]
	mov	eax, [esp]
	stosb
	inc	esi
	inc	esi
	inc	bx
	jnz	mb
	finit
	pop	eax

	;voice is now unpacked (big code for that, huh ? too much I think...)

	;init the graph
	call	init_graph

	;now open /dev/dsp O_WRONLY
	xor	eax, eax
	mov	al, 5
	mov	ebx, dsp
	xor	ecx, ecx
	inc	cl
	int	0x80
	cmp	eax, 0
	jl	sok
	inc	byte [sound_ok]
sok:
;	mov	ebx, eax
;	mov	[fd], eax

	;copy melodies at right place
	mov	esi, melodie_1-3
	mov	edi, fft_data
	mov	ecx, 1024
	rep movsd
	;melodie 2 follows immediatly melodie 1
	mov	esi, melodie_2-3
	mov	edi, ifft_data
	mov	ecx, 1024
	rep movsd

la:	call	play_some_sound
	call	put_some_graph
	jb	la

	;quit - barbarian, a core dump for the fun.
	xor	eax, eax
	dec	eax
	inc	byte [eax]

%include "sound.inc"
%include "routines.inc"
%include "graph.inc"

;not well done fft. The translation of this function :
;void ifft(void)
;{
;  register unsigned int i, j, n, m;
;
;  for (i=0; i<N; i++)
;    ifft_data[i]=fft_data[bit_reverse(i, 16-LOG2N)];
;
;  for (n=N/2, m=1; n>=1; n>>=1, m<<=1)
;    for (j=0; j<2*n; j+=2)
;      for (i=0; i<m; i++)
;	ifft_butterfly(j*m+i, (j+1)*m+i, i*n);
;
;  for (i=0; i<N; i++) {
;    register int out=ifft_data[i].r/(float)N;
;    ifft_out[i]=out>32767?32767:out<-32768?-32768:out;
;  }
;}
;with :
;void ifft_butterfly(int p1, int p2, int Wind)
;{
;  complex mul;
;
;  mul.r=ifft_data[p2].r * ifft_W[Wind].r - ifft_data[p2].i * ifft_W[Wind].i;
;  mul.i=ifft_data[p2].r * ifft_W[Wind].i + ifft_data[p2].i * ifft_W[Wind].r;
;
;  ifft_data[p2]=ifft_data[p1];
;
;  ifft_data[p1].r += mul.r;
;  ifft_data[p1].i += mul.i;
;
;  ifft_data[p2].r -= mul.r;
;  ifft_data[p2].i -= mul.i;
;}
;and:
;int bit_reverse(int x, int fs)
;{
;	register int r;
;
;	r = ((x << 8) & 0xff00) | ((x >> 8) & 0x00ff);
;	r = ((r << 4) & 0xf0f0) | ((r >> 4) & 0x0f0f);
;	r = ((r << 2) & 0xcccc) | ((r >> 2) & 0x3333);
;	r = ((r << 1) & 0xaaaa) | ((r >> 1) & 0x5555);
;	r >>= fs;
;
;	return r;
;gcc compiles something faster in -O3, damned... ! (I've got a very handling of indices.)
;But it's short in size and here, I want short stuff.
ifft:
	xor	eax, eax
	mov	esi, fft_data
	mov	edi, ifft_data
i1:	mov	ebx, eax
	mov	ecx, eax
	shr	ebx, 8
	shl	ecx, 8
	and	bx, 0x00ff
	and	cx, 0xff00
	or	ecx, ebx

	mov	ebx, ecx
	shr	ebx, 4
	shl	ecx, 4
	and	bx, 0x0f0f
	and	cx, 0xf0f0
	or	ecx, ebx

	mov	ebx, ecx
	shr	ebx, 2
	shl	ecx, 2
	and	bx, 0x3333
	and	cx, 0xcccc
	or	ecx, ebx

	mov	ebx, ecx
	shr	ebx, 1
	shl	ecx, 1
	and	bx, 0x5555
	and	cx, 0xaaaa
	or	ecx, ebx
	and	ecx, 0xffff
	mov	ebx, [esi+ecx*8]
	mov	edx, [esi+ecx*8+4]
	mov	[edi], ebx
	mov	[edi+4], edx

	;no shl needed, we are in 64Kb

	add	edi, 8
	inc	ax
	jnz	i1

	mov	esi, ifft_W
	mov	edi, ifft_data
	;disons : n=ebp   ;m=ebx   ;i=ecx   ;j=edx
	mov	ebp, N/2
	;mov	ebx, 1
	xor	ebx, ebx
	inc	bl
i2:	xor	edx, edx
i3:	xor	ecx, ecx
i4:	pusha
	imul	ebp, ecx
	;ebp=i*n ebx=m ecx=i edx=j
	mov	eax, edx
	imul	eax, ebx
	;eax=m*j
	xchg	ecx, eax
	;ebp=i*n ebx=m ecx=m*j edx=j eax=i
	add	ebx, ecx
	;ebp=i*n ebx=m*(j+1) ecx=m*j edx=j eax=i
	add	ecx, eax
	;ebp=i*n ebx=m*(j+1) ecx=m*j+i edx=j eax=i
	add	ebx, eax
	;ebp=i*n ebx=m*(j+1)+i ecx=m*j+i edx=j eax=i
	;p1=ecx p2=ebx Wind=ebp ifft_data=edi ifft_W=esi
	fld	dword [edi+ebx*8]
	fmul	dword [esi+ebp*8]
	fld	dword [edi+ebx*8+4]
	fmul	dword [esi+ebp*8+4]
	fsubp	st1

	fld	dword [edi+ebx*8]
	fmul	dword [esi+ebp*8+4]
	fld	dword [edi+ebx*8+4]
	fmul	dword [esi+ebp*8]
	faddp	st1
	;st1=mul.r
	;st0=mul.i
	fld	dword [edi+ecx*8]
	fld	dword [edi+ecx*8+4]
	;st3=mul.r
	;st2=mul.i
	;st1=[edi+ecx*8]
	;st0=[edi+ecx*8+4]
	fld	st3
	fadd	st2
	fstp	dword [edi+ecx*8]
	fld	st2
	fadd	st1
	fstp	dword [edi+ecx*8+4]
	fsubrp	st2
	fsubrp	st2
	fstp	dword [edi+ebx*8+4]
	fstp	dword [edi+ebx*8]

	popa
	inc	ecx
	cmp	ecx, ebx
	jl	i4
	inc	edx
	inc	edx
	mov	eax, ebp
	add	eax, eax
	cmp	edx, eax
	jl	i3
	shl	ebx, 1
	shr	ebp, 1
	jnz	i2

	push	dword N
	fild	dword [esp]
	xor	eax, eax
	mov	esi, ifft_out
i5:	fld	dword [edi+eax*8]
	fdiv	st0, st1
	fistp	dword [esp]
	mov	ebx, [esp]
	cmp	ebx, 32767
	jl	in1
	mov	ebx, 32767
in1:	cmp	ebx, -32768
	jg	in2
	mov	ebx, -32768
in2:	mov	[esi], ebx
	add	esi, 2
	inc	ax
	jnz	i5
	pop	eax
	finit
	ret

init_fft:
	finit
	fldpi
	fld1
	;fld1
	;faddp	st1
	fadd	st0
	fmulp	st1
	push	dword N
	fidiv	dword [esp]
	pop	eax
	xor	eax, eax
	mov	edi, ifft_W
	push	eax
if1:	fld	st0
	fimul	dword [esp]
	fld	st0
	fcos
	fstp	dword [edi+eax*8]
	fsin
	fstp	dword [edi+eax*8+4]
	inc	ax
	mov	[esp], eax
	jnz	if1
	pop	eax
	finit
	ret

dsp: db '/dev/dsp', 0

voice_data:
incbin "compressed.data"

sed:
incbin "sed.bin"

presents:
incbin "presents.bin"

fourvoyement:
incbin "fourvoyement.bin"

;align 16
end equ $
